<?php
	function make_one_page($page)
	{
		global $PAGE;
		global $FOLDER;
		
		$eol = "\n";
		// echo '<p>making page = '.$page."</p>".$eol;
		$html = file_get_contents("scripts/template_page.html");
		$html = str_replace('%%HEAD%%', '', $html);
		
		if(!array_key_exists($page, $PAGE)) {
			echo 'page '.$page." does not exist!".$eol;
			return;
		}
		
		// Build navigation
		$navigation = '<table width="100%" class="page_navigation">'.$eol.'<tr><td class="menu_group0">&nbsp;</td></tr>'.$eol;
		foreach($PAGE as $key=>$navpage)
		{
			$class='';
			
			if($navpage['level']==0) ;
			elseif(nav_the_same_tree($key, $page)) ;
			elseif(nav_the_same_group($key, $page)) ;
			elseif(nav_children_group($key, $page)) ;
			elseif(nav_parent_the_same_group($key, $page)) ;
			else continue;
			
			$class='menu_group'.$PAGE[$key]['level'];
			if($key === $page) $class = $class.' menu_selected';
			
			$file_name = $key.'.html';
			
			$navigation = $navigation.'<tr><td class="'.$class.'">'.fa_afield($file_name, $navpage['title']).'</td></tr>'.$eol;
		}
		$navigation = $navigation."</table>\n";
		$html = str_replace('%%NAVIGATION%%', $navigation, $html);
		
		//		$html = str_replace('%%MENU%%', 'SpecMan4EPR user manual: '.$PAGE[$page]['title'], $html);
		$html = str_replace('%%TITLE%%', 'SpecMan4EPR Help: '.$PAGE[$page]['title'], $html);		
		
		$page_content = 'Missing content';
		$mentioned = array();
		if(strpos($page, '*')===false && file_exists($FOLDER['content'].$page.'.txt')) {
			$page_content = file_get_contents($FOLDER['content'].$page.'.txt');
			$page_content = str_replace('SpecMan4EPR', '<span class="SpecMan">SpecMan4EPR</span>', $page_content);
			
			do {
				$a1 = strpos($page_content, '$exon$');
				$a2 = strpos($page_content, '$exoff$');
				
				if($a1 === false || $a2 ===false) break;
				
				$ppl_code = sm_color_code(substr($page_content, $a1, $a2-$a1+strlen('$exoff$')));
				$page_content = substr_replace($page_content, $ppl_code, $a1, $a2-$a1+strlen('$exoff$'));
			} while(1);
			
			$page_content = sm_color_section($page_content,'$inion$','$inioff$','Configuration file example:');
			$page_content = sm_color_section($page_content,'$exampleon$','$exampleoff$');

			do {
				$a1 = strpos($page_content, '$seeon$');
				$a2 = strpos($page_content, '$seeoff$');
				
				if($a1 === false || $a2 ===false) break;
				
				$ppl_code = set_see_also(substr($page_content, $a1, $a2-$a1+strlen('$seeoff$')));
				$page_content = substr_replace($page_content, $ppl_code, $a1, $a2-$a1+strlen('$seeoff$'));
			} while(1);
			
			ob_start();
			$page_content = sm_insert_reference($mentioned, $page_content, '', '');
			$message = ob_get_clean();
			if(!empty($message)) {
				echo 'make_page: file '.$FOLDER['content'].$page.': '.$message."<br>";
			}
		}
		else
		{
			$page_content = 'make_page: file '.$FOLDER['content'].$page.'.txt does not exist.'."\n";
		}
		$html = str_replace('%%CONTENT%%', $page_content, $html);
		
		return $html;
	}
	
	function save_one_page($page)
	{	
		global $FOLDER;
		global $PAGE;
		
		$html = make_one_page($page);
		// Save
		$efid = fopen($FOLDER['html'].'/'.$page.'.html','w');
		fwrite($efid,$html);
		fclose($efid);		
	}	
	
	function nav_the_same_tree($item, $current_page)
	{
		global $PAGE;
		
		$mpage = $current_page;
		while($item != $mpage)
		{
			if($PAGE[$mpage]['level'] == 0) return false;
			$mpage = $PAGE[$mpage]['parent'];
		}
		
		return true;
	}
	
	function nav_the_same_group($item, $current_page)
	{
		global $PAGE;
		
		if($PAGE[$current_page]['level'] == 0) return false;
		
		$parent = $PAGE[$current_page]['parent'];
		
		if($PAGE[$item]['parent'] == $PAGE[$current_page]['parent']) return true;	
		return false;	
	}
	
	function nav_children_group($item, $current_page)
	{
		global $PAGE;
		
		$children = search_by_subkey($PAGE, 'parent', $current_page);
		
		foreach($children as $key=>$value)
		{
			if($key == $item) return true;
		}
		return false;
	}
	
	function nav_parent_the_same_group($item, $current_page)
	{
		global $PAGE;
		
		if($PAGE[$current_page]['level'] == 0) return false;
		
		$parent = $PAGE[$current_page]['parent'];
		
		return nav_the_same_group($item, $parent);
	}
?>